
* https://communities.sas.com/t5/SAS-Procedures/rolling-standard-deviation-calculation/td-p/160026 ;

proc sort data=sashelp.stocks (where=(stock='IBM') keep=date close stock) out=series (drop=stock);
by date;
run;

data series;
set series;
x = _n_;
run;

proc sql;
create table want (drop=x) as
select *, (select mean(close) from series where x between a.x-4 and a.x) as rolling_mean format=dollar7.2
from series as a;
quit;

proc print data=want (obs=10);
run;

proc print data=want (firstobs=224);
run;

****************************************************************************************************;

proc sql print;
create table seriesa as select date, close from sashelp.stocks
where stock = 'IBM'
order by date;

create table seriesb as select *, monotonic() as x from seriesa;

create table wantx (drop=x) as
select *, (select mean(close) from seriesb where x between a.x-4 and a.x) as rolling_mean format=dollar7.2
from seriesb as a;
quit;

proc sql number;
ods listing close;
ods output sql_results=tempq;
select * from wantx;
ods output close;
ods listing;

select * from tempq where row <=10 or row >=224;
drop table tempq;
quit;

****************************************************************************************************;

proc sql number;
create table seriesa as select date, close from sashelp.stocks
where stock = 'IBM'
order by date;

ods listing close;
ods output sql_results=seriesb (rename=(row=x));
select * from seriesa;
ods output close;
ods listing;

create table tempq as
select *, (select mean(close) from seriesb where x between a.x-4 and a.x) as rolling_mean format=dollar7.2
from seriesb as a;
quit;

proc sql number;
select * from tempq where x <=10 or x >=224;
drop table tempq;
quit;

****************************************************************************************************;

* https://listserv.uga.edu/cgi-bin/wa?A2=ind0804b&L=SAS-L&P=188469 ;

proc sort data=sashelp.stocks (where=(stock='IBM') keep=date close stock) out=series (drop=stock);
by date;
run;

data wanty ;
set series;
array data5(0:4) _temporary_;
data5(mod(_n_,5)) = close;
rolling_mean = mean(of data5(*)) ;
format rolling_mean dollar7.2
run;

proc print data=wanty (obs=10);
run;

proc print data=wanty (firstobs=224);
run;
